unit umReg;

// Cr et maintenu par Fabrice Marguerie
// enregistrement du composant UpdateMulti et de ses diteurs

INTERFACE


procedure Register;


IMPLEMENTATION

{$R UpdateMulti.dcr}

uses
	DsgnIntf, Classes, DBTables, SysUtils, QBindDlg, DB,
  UpdateMulti;


type
  TParamsProperty = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetValue: string; override;
    function GetAttributes: TPropertyAttributes; override;
  end;


procedure TParamsProperty.Edit;
var
  NewParams:	TParams;
  Params:			TParams;
  Query:			TQuery;
  uk:					TUpdateKind;
  um:					TUpdateMulti;
begin
	inherited;
  NewParams := TParams.Create;
  try
	  Params := TParams(GetOrdValue);

	  um := GetComponent(0) as TUpdateMulti;
    Query := nil;
	  for uk := Low(TUpdateKind) to High(TUpdateKind) do
	    if (Params = um.Queries[uk].Params) then
      begin
	      Query := um.Queries[uk];
        Break;
      end;
    if Query = nil then
    	raise Exception.Create('Associated query not found');

    NewParams.Assign(Params);
    if EditQueryParams(Query, NewParams) and not NewParams.IsEqual(Params) then
    begin
      Modified;
      Query.Params := NewParams;
    end;
  finally
    NewParams.Free;
  end;
end;

function TParamsProperty.GetValue: string;
begin
  Result := Format('(%s)', [TParams.ClassName]);
end;

function TParamsProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;


// Register

procedure Register;
begin
  RegisterComponents('Cogisoft', [TUpdateMulti]);
  RegisterPropertyEditor(TypeInfo(TParams), TUpdateMulti, '', TParamsProperty);
end;

end.


